/* ***************************************************************************
 *
 *	This program is free software; you can redistribute it and/or modify it
 * 	under the terms of the Shared Code License (SCL) version 1.0 as published
 *	by www.IntellectualHeaven.com. You should have received a copy of the SCL
 *	1.0 license, look for file license.txt, along with this software; if not,
 *	then please write to x_pankaj_x@intellectualheaven.com for an electronic
 *	copy of the same.
 *
 * File name:
 * 		SfGuiTypes.cpp
 * 
 * Description:
 * 		This file declares the data types and macros used by the GUI build of
 *		the application.
 * 	
 * Revision:
 * --------------------------------------------------------------------------
 *		2005-04-24	xpankajx@intellectualheaven.com
 *		First version
 * --------------------------------------------------------------------------
 * 	Copyright (c) : Pankaj Garg
 * **************************************************************************/

#ifndef _SFGUITYPES_H_
#define _SFGUITYPES_H_

// System Include Files!!!
#include <windows.h>

// Local Include Files!!!
#include "rawnetif.h"

// Macro Definitions!!!

/*
 * status bar related data
*/
#define SFGUI_NUM_STATUS_PARTS				4		// Number of breaks in Status bar

#define SFGUI_WIDTH_OF_FIRST_PART			62		// Packet Length
#define SFGUI_WIDTH_OF_SECOND_PART			65		// Length
#define SFGUI_WIDTH_OF_THIRD_PART			50		// Packet Type
#define SFGUI_WIDTH_OF_FOURTH_PART			70		// Ethernet_II or 802.3

#define SFGUI_STATUS_BAR_HEIGHT				25
#define SFGUI_PACKET_LENGTH_STRING_WIDTH	16



/*
 * color codes
 */
#define SFGUI_IMAGE_RED            0
#define SFGUI_IMAGE_GREEN          1
#define SFGUI_IMAGE_BLUE           2
#define SFGUI_IMAGE_BLACK          3


/*
 * Error definitions
 */
#define ERR_ERROR_CODE_BASE             0x0
#define ERR_UNKNOWN                     (ERR_ERROR_CODE_BASE - 0x01)


/*
 * list control columns related
 */
#define SFGUI_MAX_COLUMN_NAME_LENGTH		64
typedef struct _ListControlHeaderData
{
	int				size;
	wchar_t			title[SFGUI_MAX_COLUMN_NAME_LENGTH];
	int				pos;
}ListControlHeaderData;


/*
 * This event is used to refresh the main list view periodically
 * to add newly received packets. Duration is in milli-seconds
 */
#define SFGUI_REFRESH_TIMER_EVENT_ID	0x202
#define SFGUI_REFRESH_TIMER_DURATION	100


#endif