/* ***************************************************************************
 *
 *	This program is free software; you can redistribute it and/or modify it
 * 	under the terms of the Shared Code License (SCL) version 1.0 as published
 *	by www.IntellectualHeaven.com. You should have received a copy of the SCL
 *	1.0 license, look for file license.txt, along with this software; if not,
 *	then please write to x_pankaj_x@intellectualheaven.com for an electronic
 *	copy of the same.
 *
 * File name:
 * 		SfGuiView.h
 * 
 * Description:
 * 		Declares the CSfGuiView class and related macros etc
 * 	
 * Revision:
 * --------------------------------------------------------------------------
 *		2005-04-24	xpankajx@intellectualheaven.com
 *		First version
 * --------------------------------------------------------------------------
 * 	Copyright (c) : Pankaj Garg
 * **************************************************************************/
#ifndef _SFGUIVIEW_H_
#define _SFGUIVIEW_H_

// System Include Files!!!
#include <windows.h>
#include <commctrl.h>

// Local Include Files!!!
#include "SfGuiTypes.h"
#include "Sf.h"


/*
 * Our Application's Title
 */
#define SFGUI_APP_TITLE		L"SnifFire - Ethernet Sniffer + Pseudo TCP/IP Firewall"



class CSfGuiView : public CSfView
{
public:
    // Constructor/Destructor!!!
    CSfGuiView(HINSTANCE hInstance);
    virtual ~CSfGuiView();

    // Functions!!!
    void InitInstance();

    LRESULT WndProc(    HWND hwnd,
                        UINT nMsg,
                        WPARAM wParam,
                        LPARAM lParam);

	HACCEL GetAccel();

	virtual void HandleNewPacket(PacketData *pPacketData);

	
private:
    // Functions!!!
    void CreateMainWindow();
    void CreateMainWindowControl();
    void CreateAndAttachImageList();
    int  CreateStatusBar();

    void PopulateStatusBarData(PacketData *inPacketData);

    int SaveAppInformation();
    int LoadAppInformation(RECT *pRect);

	bool
	InputAdapterName(RNIF_ADAPTER_INFO &adapterInfo);

	void
	UpdateMenus();

    // Data!!!

    /* 
	 * Handles for different windows controls that we use in our
	 * application
	 */
    HINSTANCE       m_hInstance;
    HWND            m_hwnd;
    HWND            m_hLVMain;
    HWND            m_hSTHexDump;
    HWND            m_hwndStatus;
    HWND            m_hwndButton;
    HPALETTE        m_hLVPalette;
    HIMAGELIST      m_hILLarge;
    HIMAGELIST      m_hILSmall;
	HACCEL			m_hAccel;

    /*
     * These variables are used to manage various menu items
	 */
	bool			m_ProtectingMyComputer;
	bool			m_SnifferActivated;
	bool			m_FirewallActivated;


	/*
	 * Total elements in main list control
	 */
	int				m_NumListElements;

	/*
	* List of all the packets we receive
	*/
	ReceivedPacketDataList m_ReceivedPackets;
};

#endif
